package com.macro.mall.tiny.modules.business.model;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.TableId;
import java.io.Serializable;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * <p>
 * 
 * </p>
 *
 * @author macro
 * @since 2021-03-28
 */
@Data
@EqualsAndHashCode(callSuper = false)
@TableName("kr_b_line_upload_log")
@ApiModel(value="BLineUploadLog对象", description="线路上传记录表")
public class KrBLineUploadLog implements Serializable {

    private static final long serialVersionUID=1L;

    @ApiModelProperty(value = "上传记录表")
    @TableId(value = "id", type = IdType.AUTO)
    private Long id;

    @ApiModelProperty(value = "上传线路名称")
    private Long lineId;

    @JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty(value = "上传日期")
    private Date uploadTime;

    @ApiModelProperty(value = "上传状态：0-失败，1-成功")
    private Integer status;

    @ApiModelProperty(value = "警告信息")
    private String warnMsg;

    @ApiModelProperty(value = "所属线路名称")
    @TableField(exist = false)
    private String lineName;

    @ApiModelProperty(value = "上传者名称")
    private String uploaderName;


}
